package com.normal.scorpio.robotumnik1;

import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

import java.io.BufferedWriter;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * Created by User on 12/12/2017.
 * Регулярные выражения
 * https://regex101.com/
 * http://regexpres.narod.ru/calculator.html
 * быстродействие https://javatalks.ru/topics/4747
 */
public class Reglas {
    private String InfoTxt="G ПОМОЩЬ:;" +
            "СОТРИ ФРАГМЕНТ –; стирается последний фрагмент;" +
            "СОТРИ ПРАВИЛО –; стираются все фрагменты;" +
            "ПОВТОРИ ПРАВИЛО –; робот повторяет правило целиком;" +
            "СОХРАНИ ПРАВИЛО –; правило проверяется  и добавляется в файл;" +
            "ВЫПОЛНИ ПРАВИЛО –; выполняется функциональная часть правила;" +
            "ОТКРОЙ ПРАВИЛО –; сохраняет правило и открывает его в редакторе;" +
            "ВЫХОД –; выход из редактора правил ,БЕЗ СОХРАНЕНИЯ";

    private final static String TAG = MainActivity.TAG+" RG";
    private static final String PATH = "sdcard/RobotUmnik/RoboReglas.txt";
    //private static final String PATH = "RoboReglas.txt";
    int MASSAGE_DELAY=0;
    //private String reglasstr;
    private boolean IsReglas=false;
    private boolean IsInit=false;
    private String reglaedit;
    private String reglafragment;
    private boolean IsSaved=false;

    ArrayList<String> KeyWordsOperators=new ArrayList<String>(Arrays.asList(
            "когда",
            "если",
            "то",
            "иначе",
            "или",
            "и",
            "не"
    ));
    ArrayList<String> KeyWordsEvents=new ArrayList<String>(Arrays.asList(
            "скажу",
            "спрошу"
     ));
    ArrayList<String> KeyWordsVEvents=new ArrayList<String>(Arrays.asList(
            "скажу",
            "спрошу",
            "услышишь"
    ));
    ArrayList<String> KeyWordsFunctions=new ArrayList<String>(Arrays.asList(
            "подмигни",
            "api1",
            "api2",
            "api3",
            "api4"
    ));
    ArrayList<String> KeyWordsVFunctions=new ArrayList<String>(Arrays.asList(
            "скажи",
            "ответь"
    ));
    ArrayList<String> KeyWordsAFunctions=new ArrayList<String>(Arrays.asList(
            "установи",
            "сбрось",
            "поднят"
    ));
    ArrayList<String> KeyWords= new ArrayList<String>();

    //ArrayList<String> reglaslist=new ArrayList<String>();
    ArrayList<EventStructure> events= new ArrayList<EventStructure>();

    int CurrentRegla=0;
    IndStructure voiceind=new IndStructure();
    IndStructure voiceEind=new IndStructure();
    IndStructure eventind=new IndStructure();
    Flags flags=new Flags();
    public boolean IsEditor=false;

    Handler h;
    Reglas(Handler H){
        h=H;

    }

    public void init(){
        KeyWordsEvents.addAll(KeyWordsVEvents);
        KeyWordsFunctions.addAll(KeyWordsVFunctions);
        KeyWordsFunctions.addAll(KeyWordsAFunctions);
        KeyWords=KeyWordsEvents;
        KeyWords.addAll(KeyWordsFunctions);
//TODO создание нового файла при его отсутствии
        IsInit=ReadReglas();
        //if(!IsInit)return;
        //Test();

    }
    int minutecounter=0;
    public void Tick(){
        minutecounter++;
        if(minutecounter>60){
            minutecounter=0;
            flags.TickFlags();
        }
    }
    private boolean ReadReglas(){

        String reglasstr=getStringFromRawFile();
        Log.e(TAG,reglasstr);
        if(reglasstr==null || reglasstr.isEmpty()){
            Log.e(TAG,"Read Reglas error");
            return false;
        }
        reglasstr=reglasstr.toLowerCase();//переведем в нижний регистр
        reglasstr=reglasstr.replaceAll("\\s+", " ");//заменим все разделительные символы и их группы на пробелы
        reglasstr=reglasstr.trim();//уберем лишние пробелы
        //Log.i(TAG,reglasstr);

        String[] reglas=reglasstr.split("#");//разделим правила
        for(int i=0;i<reglas.length;i++){
            //Log.i(TAG,reglas[i]);
            String reglatmp=ReglaNormalized(reglas[i].trim());//нормализуем
            //Log.e(TAG,reglatmp);
            if(!IsRegla(reglatmp)){//строка не является правилом
                Log.e(TAG,"NO REGLA!");
                continue;
            }
            AddRegla(reglatmp);
            IsReglas=true;
        }

        return true;
    }
    private String ReglaNormalized(String regla){//возвращает правило, лишенное не значащих элементов
        String output="";

        String[] regs=regla.split(" ");
        boolean txtflag=false;
        boolean voiceflag=false;
        boolean txtvoiceflag=false;
        boolean argflag=false;
        boolean argtxtflag=false;
        for(String reg:regs){//для каждого слова строки..
            String tmp="";

            if(txtflag) {
                if (reg.endsWith("\"")) //ищем фразу в кавычках..
                    txtflag = false;
                tmp = reg;

            } else {
                if (reg.startsWith("\"")) {
                    tmp = reg;
                    txtflag = true;
                    voiceflag=false;
                } else {

                    //автоматическое определение начала/конца фразы без кавычек
                    if(voiceflag){tmp="\""+reg;voiceflag=false;txtvoiceflag=true;}
                    else if(argflag){tmp="("+reg;argflag=false;argtxtflag=true;}
                    else {
                        tmp = StrKeyWords(reg);//либо ключевые слова

                        if (txtvoiceflag || argtxtflag) {
                            if (!tmp.isEmpty()) {
                                String fin="\" ";
                                if (txtvoiceflag)txtvoiceflag = false;
                                else {argtxtflag = false;fin= ") ";}
                                output = output.trim();
                                output +=fin;
                            }//закрываем кавычку для фразы или скобку для аргументов
                            else tmp = reg;
                         } else {
                            if (IsVKeyWord(tmp)) {
                                voiceflag = true;
                            }//открываем кавычку для фразы
                            else if (IsAKeyWord(tmp)) {
                                argflag = true;
                            }//открываем скобку для аргументов
                        }
                    }

                }
            }
            if(!tmp.isEmpty()){
                //if(!tmp.endsWith(" \""))output+=" ";
                output+=tmp+" ";// получим в результате правило без лишних слов и фразами в кавычках
            }
        }

        if(txtvoiceflag || txtflag){output=output.trim();output+="\" ";}//добавим кавычку в конец текста
        else if(argtxtflag){output=output.trim();output+=") ";}//добавим скобку в конец текста
        return output;
    }

    //если входное слово начинается с ключа, возвращает кс, помеченное спец символом
    //операторы должны полностью совпадать
    //окончания событий и функций могут отличаться, но не более, чем на 2 символа
    private String StrKeyWords(String str){
        String ch="";
        if(str.endsWith(","))ch=",";
        for(String tmp:KeyWords){
            if(str.startsWith(tmp)&& Math.abs(str.length()-tmp.length())<3)return tmp+"%"+ch;
        }
        for(String tmp:KeyWordsOperators){
            if(str.equals(tmp))return tmp+"%"+ch;
        }
        return "";
    }
    private boolean IsAKeyWord(String word){
        for(String tmp:KeyWordsAFunctions){
            if(word.startsWith(tmp))return true;
        }
        return false;
    }
    private boolean IsVKeyWord(String word){
        for(String tmp:KeyWordsVEvents){
            if(word.startsWith(tmp))return true;
        }
        for(String tmp:KeyWordsVFunctions){
            if(word.startsWith(tmp))return true;
        }
        return false;
    }

    private void AddRegla(String regla){//добавление нового правила
        events.add(new EventStructure());
        String eventpart=ExstractStr(regla,"когда% "," то% ");//описание события
        String ifpart=ExstractStr(eventpart, " если% ");//основное условие (если условия нет, будет "")
        if(!ifpart.isEmpty())eventpart=ExstractStr(regla,"когда% "," если% ");
        regla=ExstractStr(regla," то% ");//описание действий
        events.get(CurrentRegla).MainIf=ifpart; //добавление общего условия
        //добавление описания события
        String tmp=ExstractStr(eventpart, " \"", "\"");
        //Log.e(TAG,"NEW REGLA "+CurrentRegla);
        if(!tmp.isEmpty()){//если событие голосовое
            if(eventpart.contains("услышишь% "))voiceind.addFrase(tmp,CurrentRegla);
            else voiceEind.addFrase(tmp,CurrentRegla);
            voiceind.IsEmpty=false;
            //Log.e(TAG, "VOICE EVENT: " + tmp);
        }
        else {
            eventind.addFrase(eventpart,CurrentRegla);//для других типов событий
            eventind.IsEmpty=false;
            //Log.e(TAG, "EVENT: " + eventpart);
        }

        //Log.e(TAG,"IF PART: "+ifpart);
        //Log.e(TAG,"ACT PART: "+regla);
        //добавление действий
        String[] actions=regla.split(",");//группы действий разделены запятыми
        for(int i=0;i<actions.length;i++)AddAction(actions[i]);
        CurrentRegla++;
    }
    private void AddAction(String act){
        String ifcond=ExstractStr(act, "если% ", " то% ");//локальное условие (если условия нет, будет "")
        String ifact=act;
        String elseact=ExstractStr(act, " иначе% ");
        if(!ifcond.isEmpty()){
            if(elseact.isEmpty())ifact=ExstractStr(act, " то% ");
            else ifact=ExstractStr(act, " то% "," иначе%");
        }
        events.get(CurrentRegla).AddActions(ifcond,ifact,elseact);
        //Log.e(TAG, "IF:" + ifcond);
        //Log.e(TAG, "IF ACT:"+ifact);
        //Log.e(TAG, "ELSE ACT:"+elseact);
    }

    private boolean IsRegla(String str){ // проверяет, является ли строка правилом
        if(!str.startsWith("когда"))return false;// правило должно начинаться со слова "когда"
        String tmp=ExstractStr(str,"когда% "," то% ");
        //Log.i(TAG, tmp);
        if(tmp.isEmpty())return false;//должно иметь хотябы один разделитель "то"
        boolean test=false;
        for (String event : KeyWordsEvents) {
            if(tmp.contains(event +"%")){test=true;break;}
        }
        if(!test)return false;// после "когда" должно быть имя события
        test=false;
        tmp=ExstractStr(str," то% ");
        for (String fn : KeyWordsFunctions) {
            if(tmp.contains(fn+"%")){test=true;break;}
        }
        if(!test)return false;// после "то" д.б. задана хотябы одна функция
        return true;
    }
    private class IndStructure{
        ArrayList<String> Frases = new ArrayList<String>();
        ArrayList<Integer> indexes = new ArrayList<Integer>();
        public boolean IsEmpty=true;
        public void addFrase(String frase, int eventnum){
            Frases.add(frase);
            indexes.add(eventnum);
        }
        public  int getNumE(String frase){//возвращает номер правила для точно совпавшей фразы
            int num=Frases.indexOf(frase);
            if(num>-1)return indexes.get(num);
            else return -1;
        }
        public  int getNum(String frase){//возвращает номер правила для частично совпавшей фразы
            int num=-1;
            for(int i=0;i<Frases.size();i++){
                if(frase.contains(Frases.get(i))){num=i;break;}
            }
            if(num>-1)return indexes.get(num);
            else return -1;
        }
    }
    private class EventStructure{
        public String MainIf="";
        public int CurrentAction=0;
        public ArrayList<FunStruct> Act=new ArrayList<FunStruct>();

        public void AddActions(String IfCond,String IfAct,String ElAct){
            Act.add(new FunStruct());
            Act.get(CurrentAction).LocalIf=IfCond;
            Act.get(CurrentAction).LocalIfFun=IfAct;
            Act.get(CurrentAction).LocalElseFun=ElAct;
            CurrentAction++;
        }
    }
    private class FunStruct{
        public String LocalIf="";
        public String LocalIfFun="";
        public String LocalElseFun="";
    }
    private String ExstractStr(String instr, String startstr,String endstr) {
       // Log.i(TAG, instr);
        String outstr ="";
       try {
            int stindex=instr.indexOf(startstr);if(stindex<0)return "";
            int endindex=instr.indexOf(endstr,stindex+startstr.length());if(endindex<0)return "";
            outstr = instr.substring(stindex+ startstr.length(), endindex);
       }catch (IndexOutOfBoundsException e){};

       // Log.i(TAG, outstr);
        if(!outstr.isEmpty())return outstr.trim();
        else return "";
    }
    private String ExstractStr(String instr, String startstr) {
        // Log.i(TAG, instr);
        String outstr ="";
        try {
            int stindex=instr.indexOf(startstr);if(stindex<0)return "";
            outstr = instr.substring(stindex+ startstr.length());
        }catch (IndexOutOfBoundsException e){};

        // Log.i(TAG, outstr);
        if(!outstr.isEmpty())return outstr.trim();
        else return "";
    }
    private String ExtractFirst(String instr){//извлечение первого слова из строки
        if(!instr.contains(" "))return instr;
        else{
            String[] tmp=instr.split(" ");
            return tmp[0];
        }
    }
    private String ExtractFirst(String instr,int num){//извлечение слова из строки
        if(!instr.contains(" "))return instr;
        else{
            String[] tmp=instr.split(" ");
            if(tmp.length>num) return tmp[num];
            else return "";
        }
    }


    // работа с файлом
    private boolean AddReglaToFile(String regla)
    {
        File file = new File(PATH);
        try {
            if (!file.exists())file.createNewFile();

            BufferedWriter bw = new BufferedWriter(new FileWriter(file, true));
            bw.append(regla);
            bw.close();
            Log.i(TAG, "Safe New Regla OK");
            Log.e(TAG,getStringFromRawFile());
            return true;
        } catch (IOException e) {
            e.printStackTrace();
            Log.e(TAG, "Write Reglas error:"+e.toString());
            return false;
        }
    }
    private String  getStringFromRawFile() {//возвращает строку из текстового файла , преобразованную в нижний регистр

        InputStream is = null;
        String myText = null;
        try {

            // open input stream test.txt for reading purpose.
            is = new FileInputStream(PATH);
            myText = convertStreamToString(is);
            is.close();

        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }


        if (myText != null) {
            myText= myText.toLowerCase();
        }
        return  myText;
    }

    private String  convertStreamToString(InputStream is) throws IOException {
        ByteArrayOutputStream baos = new ByteArrayOutputStream();
        int i = is.read();
        while( i != -1)
        {
            baos.write(i);
            i = is.read();
        }
        return  baos.toString();
    }


    private void Speak(String phrase){
        Log.i(TAG, "Speak: "+phrase);
        RobotStatus.TTS.IsSpeaking=true;
        Message msg = h.obtainMessage(Dispatcher.MSG_TOWN_SPEAK, phrase);//
        h.sendMessageDelayed(msg,MASSAGE_DELAY);
    }


    private void ExecuteRegla(int regla){
        Log.i(TAG, "EXECUTE REGLA: "+regla);
        String tmp=events.get(regla).MainIf;
        if(tmp.isEmpty() || CheckIfs(tmp)){
            for(int i=0;i<events.get(regla).CurrentAction;i++){
                tmp=events.get(regla).Act.get(i).LocalIf;
                if(tmp.isEmpty())MakeActions(events.get(regla).Act.get(i).LocalIfFun);
                else{
                   if(CheckIfs(tmp))MakeActions(events.get(regla).Act.get(i).LocalIfFun);
                   else MakeActions(events.get(regla).Act.get(i).LocalElseFun);
                }
            }
        }
    }
    private void MakeActions(String actions){
        if(actions.isEmpty())return;
        //Log.e(TAG, "MAKE ACTS: "+actions);
        String[] tmp;
        if(actions.contains(" и% ")) {
            tmp = actions.split(" и% ");
            for(int i=0;i<tmp.length;i++){
                MakeAct(tmp[i]);
            }
        }else if(actions.contains(" или% ")) {
            tmp = actions.split(" или% ");
            int index=(int)(Math.random()*(tmp.length-1));
            MakeAct(tmp[index]);
        }else MakeAct(actions);
    }
    private void MakeAct(String act){
        //Log.e(TAG, "MAKE ACT: " + act);
        String arg=ExstractStr(act," \"","\"");
       // Log.i(TAG,arg);
        if(arg.isEmpty())arg=ExstractStr(act, " (", ")");
       // Log.i(TAG,arg);
        act=ExtractFirst(act);
        FunExecute(act,arg);
    }
    //м.б. не более 2х условий разделенных логикой И или ИЛИ
    private boolean CheckIfs(String cond){
        String[] tmp;
        if(cond.contains(" и% ")){
            tmp=cond.split(" и% ");
            if(tmp.length !=2)return false;
            if(CheckIf(tmp[0])&& CheckIf(tmp[1]))return true;
            else return false;
        }else if(cond.contains(" или% ")){
            tmp=cond.split(" или% ");
            if(tmp.length !=2)return false;
            if(CheckIf(tmp[0])|| CheckIf(tmp[1]))return true;
            else return false;
        }
        return CheckIf(cond);//только одно условие
    }
    private boolean CheckIf(String cond){
        cond=cond.trim();
        String args=ExstractStr(cond, "(", ")");//аргументы функции
        boolean ne=cond.startsWith("не% ");
        if(ne)cond=ExtractFirst(cond,1);//функция
        else cond=ExtractFirst(cond);
        if(cond.isEmpty())return false;
        else return ne^FunExecute(cond, args);
    }
    private boolean FunExecute(String func, String args){
        //Log.e(TAG,"MAKE FUNC: "+func+" ARG: "+args);
        if(func.equals("поднят%")){//проверка состояния флага
            if(args.isEmpty())return false;//нет аргумента
            int num=ReturnNum(args);
            if(num>-1)return flags.CheckFlag(num);//состояние флага
            else return false;//аргумент не является числом
        }
        if(func.equals("сбрось%")){//сброс флага
            if(args.isEmpty())return false;//нет аргумента
            int num=ReturnNum(args);
            if(num>-1){
                if(num==10)flags.ResetAll();//сброс всех флагов
                else flags.ResetFlag(num);//сброс флага
                return true;
            }
            else return false;//аргумент не является числом
        }
        if(func.equals("установи%")){//установка флага
            if(args.isEmpty())return false;//нет аргумента
            String tmp=ExstractStr(args," на ");
            int timer=-1;
            if(!tmp.isEmpty()){//время в минутах
                timer=ReturnNum(tmp);
            }
            int num=ReturnNum(args);
            if(num>-1){
                flags.SetFlag(num,timer);//установка таймера
                return true;
            }
            else return false;//аргумент не является числом
        }
        if(func.equals("скажи%")||func.equals("ответь%")) {//
            if(args.isEmpty())return false;//нет аргумента
            Speak(args);
            return true;
        }
        return false;
    }
    private int ReturnNum(String args){//возвращает первое содержащееся в строке число
        String[] tmp;
        if(args.contains(" ")) {
            tmp = args.split(" ");
            int num=-1;
            for(int i=0;i<tmp.length;i++){
                num=ConvertToNum(tmp[i]);
                if(num>-1)return num;
            }
            return -1;
        } else return ConvertToNum(args);
    }
    private int ConvertToNum(String input) {
        int result=-1;
        try {
            result=Integer.parseInt(input);
        } catch (NumberFormatException e) {}
        return result;
    }
    private class Flags{//10 флагов для организации логики диалогов.
        public int state[] ={0,0,0,0,0,0,0,0,0,0};

        public void SetFlag(int flagnum){
            SetFlag(flagnum,-1);
        }
        public void SetFlag(int flagnum,int timeseg){
            if(flagnum>9)flagnum=9;
            else if(flagnum<0)flagnum=0;
            state[flagnum]=timeseg;
            //Log.e(TAG, "Flag " + flagnum + " is SETING to " + timeseg);
        }
        public void ResetFlag(int flagnum){
            SetFlag(flagnum, 0);
            //Log.e(TAG, "Flag " + flagnum + " is RESETING");
        }
        public void ResetAll(){
            for(int i=0;i<10;i++)SetFlag(i,0);
            //Log.e(TAG, "All Flags is RESETING");
        }
        public boolean CheckFlag(int flagnum){
            if(state[flagnum]==0)return false;
            else return true;
        }
        public void TickFlags(){
            for(int i=0;i<10;i++){
                if(state[i]>0){
                    state[i]--;
                    if(state[i]==0)Log.e(TAG, "Flag " + i + " is RESETING");
                }
            }
        }
    }
    public boolean VoiceEvent(String frase){
        if(!IsReglas || !IsInit)return false;
        //Log.e(TAG, "VOICE EVENT: "+frase);
        if(IsEditor){Editor(frase);return true;}
        else if(frase.equals("запиши новое правило")){
            reglaedit="";
            reglafragment="";
            IsSaved=false;
            IsEditor=true;
            RobotStatus.InfoText=InfoTxt;
            Speak("Я готов записать новое правило");
            return true;
        }else {
            int num = voiceEind.getNumE(frase);//точное совпадение
            if (num > -1) {
                ExecuteRegla(num);
                return true;
            } else {
                num = voiceind.getNum(frase);//частичное совпадение
                if (num > -1) {
                    ExecuteRegla(num);
                    return true;
                }
            }
            return false;
        }
    }

    public void Event(String event){
        if(!IsReglas || !IsInit)return;
        int num=eventind.getNum(event);
        if(num>-1)ExecuteRegla(num);
    }
    public void Test(){
//        VoiceEvent("как жизнь");
//        VoiceEvent("привет робот");
//        VoiceEvent("привет робот");
        AddReglaToFile("\n TEST");
    }
    private void Editor(String frase){
        if(frase.equals("сотри фрагмент")){
            if(!reglafragment.isEmpty()){
                reglafragment="";
                Speak("последний фрагмент правила удален");
            }else
            Speak("фрагмент ещё не создан!");
            return;
        }
        if(frase.startsWith("cотри правил")){
            if(!reglaedit.isEmpty()){
                reglaedit="";
                reglafragment="";
                IsSaved=false;
                Speak("правило удалено");
            }
            Speak("правило ещё не создано!");
            return;
        }
        if(frase.startsWith("повтори правил")){
            reglaedit+=" "+reglafragment;
            if(!reglaedit.isEmpty())Speak(reglaedit);
            else Speak("правило ещё не создано!");
            return;
        }
        if(frase.startsWith("сохрани правил")){
            if(IsSaved) Speak("Правило уже сохранено!");
            else{
                reglaedit+=" "+reglafragment;
                IsSaved=SaveNewRegla(reglaedit);
            }
            return;
        }
        if(frase.equals("выполни правил")){
            reglaedit+=" "+reglafragment;
            if(!IsSaved)
            IsSaved=SaveNewRegla(reglaedit);
            if(IsSaved){
                ExecuteRegla(CurrentRegla-1);
            }else{
                Speak("До выполнения, правило должно быть сохранено.");
            }
            return;
        }
        if(frase.equals("выход")){
            ExitEditor();
            return;
        }
        reglaedit+=" "+reglafragment;
        reglafragment=frase;
    }
    private void ExitEditor(){
        IsEditor=false;
        RobotStatus.InfoText=RobotStatus.mainInfoText;
        Speak("Работа редактора завершена.");
        if(!reglaedit.isEmpty()) {
            if (IsSaved) Speak("Новое правило сохранено.");
            else Speak("Новое правило не сохранено!");
        }
    }
    private boolean SaveNewRegla(String newregla){
        if(newregla.isEmpty()){
            Speak("Нужно создать правило, прежде чем его сохранять!");
            return false;
        }
        String tmp=ReglaNormalized(newregla);
        if(IsRegla(tmp)){
            if(AddReglaToFile(MejorarRegla(newregla))) {
                Speak("Правило сохранено.");
                AddRegla(tmp);
                return true;
            }
            else
                Speak("Ошибка записи в файл. Правило не сохранено!");

        }else{
            Speak("Правило содержит ошибки. Правило не сохранено!");
        }
        return false;
    }
    private String MejorarRegla(String regl){
        regl=regl.replace("то ", "то \n\t");
        regl=regl.replace(", ",", \n\t");
        return "\n#\n"+regl;
    }


}
